<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'documento.php';

function cpf_valido($codigo)/*{{{*/
{
	if(strlen($codigo) != 11 || !ctype_digit($codigo))
		return false;

	// Eh mais rápido testar se o codigo eh composto de
	// digitos iguais assim...
	$igual = true;
	for($j=1; $j<11; ++$j)
	{
		if($codigo[$j] != $codigo[$j-1])
		{
			$igual = false;
			break;
		}
	}
	if($igual)
		return false;

	$soma = 0;
	for($i=0; $i<9; ++$i)
		$soma += $codigo[$i] * (10-$i);

	$dv = 11 - $soma % 11;
	if($dv >= 10)
		$dv = 0;

	if($dv != $codigo[9])
		return false;

	$soma = 2*$dv;
	for ($i=0; $i<9; ++$i)
		$soma += $codigo[$i] * (11-$i);

	$dv = 11 - $soma % 11;
	if ($dv >= 10)
		$dv = 0;

	return $dv==$codigo[10];
}/*}}}*/
function output_cpf($cpf)/*{{{*/
{
	if($cpf)
	{
		if(is_numeric($cpf))
		{
			return substr($cpf, 0, 3).'.'.
				   substr($cpf, 3, 3).'.'.
				   substr($cpf, 6, 3).'-'.
				   substr($cpf, 9, 2);
		}
		else
			return $cpf;
	}
	else
		return '';
}/*}}}*/
function input_cpf($cpf)/*{{{*/
{
	if($cpf)
	{
		return substr($cpf, 0, 3).
			   substr($cpf, 4, 3).
			   substr($cpf, 8, 3).
			   substr($cpf, 12, 2);
	}
	else
		return '';
}/*}}}*/

class CPF extends Documento
{
	function setTableDefinition()
	{
		$this->setTableName('saude.cpf');
		$this->hasColumn('numero','string', 11, 
			// infelizmente nao ha garantias que o cpf possa ser unico...
			array('fixed','notnull','notblank'));

		$this->hasColumn('idpessoa', 'integer', NULL, array('notnull'));

		Documento::setTableDefinition();
	}

	function validate()
	{
		Documento::validate();

		$erros = array();

		if(!$this->numero)
			$erros[] = 'O numero do CPF deve ser informado';
		else if(!cpf_valido($this->numero))
			$erros[] = 'Número do CPF inválido';

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

	function setUp()
	{
		Documento::setUp();

		$this->index('unique_pessoa_cpf',
			array('fields'=>array('idpessoa'),
			      'type'=>'unique'));

		$this->hasOne('Pessoa as pessoa',
			array('local'=>'idpessoa',
			      'foreign'=>'id'));
	}
};

?>
